#include<bits/stdc++.h>
using namespace std;

int n;
vector<int> haha(100001);
vector<int> d[100001];
vector<int> u[100001];

void calc() {
    int a,b,c;
    cin >> a >> b;
    vector<int> bruh(n+1);
    queue<int> idk;
    idk.push(a);
    while(!idk.empty()) {
        c = idk.front();
        for(int i = 0; i < d[c].size(); i++) {
            if(bruh[d[c][i]] == 0) {
                bruh[d[c][i]] = 1;
                idk.push(d[c][i]);
            }
        }
        idk.pop();
    }
    idk.push(b);
    idk[b]
    while(!idk.empty()) {
        c = idk.front();
        for(int i = 0; i < u[c].size(); i++) {
            if(bruh[u[c][i]] < 2) {
                bruh[u[c][i]] += 2;
                idk.push(u[c][i]);
            }
        }
        idk.pop();
    }
    for(int i = 0; i <= n; i++) {
        if(bruh[i] == 3) {
            haha[i]++;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int m,k,a,b;
    cin >> n >> m >> k;
    for(int i = 0; i < m; i++) {
        cin >> a >> b;
        d[a].push_back(b);
        u[b].push_back(a);
    }
    for(int i = 0; i < )
    return 0;
}
